﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;

namespace COA.EnterpriseServices.DataAccess.EntityFramework
{
    public class EntityDataAccess<T> : IDataAccess<T> where T : class, IRecord
    {
        public bool Add(T item)
        {
            using (var context = new QuickBaseContext())
            {
                context.Add(item);

                context.SaveChanges();
            }

            return true;
        }

        public bool Update(T item)
        {
            using (var context = new QuickBaseContext())
            {
                context.Entry(item);

                context.SaveChanges();
            }

            return true;
        }

        public T Get(int id)
        {
            return Get(r => r.Id == id).FirstOrDefault();
        }

        public ICollection<T> Get(Expression<Func<T, bool>> query)
        {
            using (var context = new QuickBaseContext())
            {
                return context
                    .Set<T>()
                    .Where(query)
                    .ToList();
            }
        }
    }
}
